/****************************************************************************/
/* AiOZTAT[{fJ[ ZbgPWM[h2008           */
/*                          2008.05 Wp}CRJ[[sψ    */
/****************************************************************************/

/*======================================*/
/* CN[h                         */
/*======================================*/
#include    <no_float.h>                /* stdio̊ȗ ŏɒu     */
#include    <stdio.h>                   /* printfȂǗp                 */
#include    <machine.h>                 /* gݍ݊֐p               */
#include    "h8_3048.h"                 /* H8/3048F-ONEWX^`     */

/*======================================*/
/* V{`                         */
/*======================================*/

/* 萔ݒ */
#define     TIMER_CYCLE         3071    /* ^C}̃TCN 1ms         */
#define     PWM_CYCLE           3071    /* [^PWM̃TCN 1ms      */

/*======================================*/
/* vg^Cv錾                     */
/*======================================*/
void init( void );
unsigned char sensor_inp( void );
unsigned char center_inp( void );
unsigned char startbar_get( void );
unsigned char dipsw_get( void );
unsigned char pushsw_get( void );
void led_out( unsigned char led );
void speed( int accele_l, int accele_r );
void speed2( int accele_l, int accele_r );
void servoPwmOut( int pwm );
int check_crossline( void );
int getServoAngle( void );
int getAnalogSensor( void );
void servoControl( void );
int diff( int pwm );

/*======================================*/
/* O[oϐ̐錾                 */
/*======================================*/
int             pattern;                /* }CRJ[p^[     */
int             crank_mode;             /* 1:NN[h 0:ʏ      */
unsigned long   cnt1;                   /* ^C}p                     */

/*  T[{֘A */
int             iSensorBefore;          /* ÕZTlۑ           */
int             iServoPwm;              /* T[{ovll               */
int             iAngle0;                /* SA/Dlۑ            */

/* ZT֘A */
int             iSensorPattern;         /* ZTԕێp             */

/* ֍lvZp@e}CRJ[ɍ킹čČvZĉ */
const revolution_difference[] = {       /* pxցAO։]vZ */
    100, 98, 97, 95, 94,
    92, 91, 89, 88, 87,
    85, 84, 82, 81, 80,
    78, 77, 76, 74, 73,
    72, 70, 69, 68, 66,
    65, 64, 62, 61, 60,
    58, 57, 56, 54, 53,
    52, 50, 49, 48, 46,
    45, 43, 42, 40, 39,
    38 };

/************************************************************************/
/* CvO                                                     */
/************************************************************************/
void main( void )
{
    int             i;
    unsigned char   c;

    /* }CR@\̏ */
    init();                             /*                        */
    init_sci1( 0x00, 79 );              /* SCI1                   */
    set_ccr( 0x00 );                    /* S̊荞݋             */

    /* }CRJ[̏ԏ */
    speed( 0, 0 );
    servoPwmOut( 0 );

    while( 1 ) {

    switch( pattern ) {
    case 0:
        /* vbVXCb`҂ */
        servoPwmOut( 0 );
        if( pushsw_get() ) {
            pattern = 1;
            cnt1 = 0;
            break;
        }
        if( cnt1 < 100 ) {              /* LED_ŏ                  */
            led_out( 0x1 );
        } else if( cnt1 < 200 ) {
            led_out( 0x2 );
        } else {
            cnt1 = 0;
        }
        break;

    case 1:
        /* X^[go[J҂ */
        servoPwmOut( iServoPwm / 2 );
        if( !startbar_get() ) {
            iAngle0 = getServoAngle();  /* 0ẍʒuL                */
            led_out( 0x0 );
            pattern = 11;
            cnt1 = 0;
            break;
        }
        if( cnt1 < 50 ) {              /* LED_ŏ                   */
            led_out( 0x1 );
        } else if( cnt1 < 100 ) {
            led_out( 0x2 );
        } else {
            cnt1 = 0;
        }
        break;

    case 11:
        /* ʏg[X */
        servoPwmOut( iServoPwm );
        i = getServoAngle();
        if( i > 170 ) {
            speed( 0, 0 );
        } else if( i > 25 ) {
            speed( diff(80), 80 );
        } else if( i < -170 ) {
            speed( 0, 0 );
        } else if( i < -25 ) {
            speed( 80, diff(80) );
        } else {
            speed( 100, 100 );
        }
        if( check_crossline() ) {       /* NXC`FbN         */
            crank_mode = 1;
            pattern = 21;
            cnt1 = 0;
        }
        break;

    case 21:
        /* NXCʉߏ */
        servoPwmOut( iServoPwm );
        led_out( 0x3 );
        speed( 0, 0 );
        if( cnt1 >= 100 ) {
            pattern = 22;
            cnt1 = 0;
        }
        break;

    case 22:
        /* NXC̃g[XApo */
        servoPwmOut( iServoPwm );
        speed( 40, 40 );

        if( (sensor_inp()&0x01) == 0x01 ) { /* ENNH             */
            led_out( 0x1 );
            pattern = 31;
            cnt1 = 0;
            break;
        }
        if( (sensor_inp()&0x08) == 0x08 ) {  /* NNH            */
            led_out( 0x2 );
            pattern = 41;
            cnt1 = 0;
            break;
        }
        break;

    case 31:
        /* ENN */
        servoPwmOut( 50 );          /* U肪アƂ͑傫       */
        speed( 60, 27 );
        if( sensor_inp() == 0x04 ) {    /* ȂI`FbN           */
            iSensorPattern = 0;
            crank_mode = 0;
            pattern = 32;
            cnt1 = 0;
        }
        break;

    case 32:
        /* Ԃo܂ő҂ */
        servoPwmOut( iServoPwm );
        speed2( 80, 80 );
        if( cnt1 >= 100 ) {
            led_out( 0x0 );
            pattern = 11;
        }
        break;

    case 41:
        /* NN */
        servoPwmOut( -50 );         /* U肪アƂ͑傫       */
        speed( 27, 60 );
        if( sensor_inp() == 0x02 ) {    /* ȂI`FbN           */
            iSensorPattern = 0;
            crank_mode = 0;
            pattern = 42;
            cnt1 = 0;
        }
        break;

    case 42:
        /* Ԃo܂ő҂ */
        servoPwmOut( iServoPwm );
        speed2( 80, 80 );
        if( cnt1 >= 100 ) {
            led_out( 0x0 );
            pattern = 11;
        }
        break;

    default:
        break;
    }
    }
}

/************************************************************************/
/* H8/3048F-ONE Ӌ@\̏                                    */
/************************************************************************/
void init( void )
{
    /* |[g̓o͐ݒ */
    P1DDR = 0xff;
    P2DDR = 0xff;
    P3DDR = 0xff;
    P4DDR = 0xff;
    P5DDR = 0xff;
    P6DDR = 0xf0;                       /* CPUDIP SW            */
    P8DDR = 0xff;
    P9DDR = 0xf7;
    PADDR = 0xf7;                       /* bit3:X^[go[            *//*------ ύX ------*/
	                                    /*                              */
    PBDR  = 0x80;                                                         /*------ ύX ------*/
    PBDDR = 0xfe;                       /* [^hCuVer3       */

    /* A/D */
    AD_CSR  = 0x12;                     /* XL[hAN2-0          *//*------ ύX ------*/
    AD_CSR |= 0x20;                     /* A/DϊJn                  */

    /* ITU0 1msƂ̊荞 */
    ITU0_TCR = 0x23;                    /* JE^ANA̐ݒ       */
    ITU0_GRA = TIMER_CYCLE;             /* 荞ݎ̐ݒ           */
    ITU0_IER = 0x01;                    /* 荞ݐ                 */

    /* ITU3,4 ZbgPWM[h E[^AT[{p */
    ITU3_TCR = 0x23;                    /* JE^ANA̐ݒ       */
    ITU_FCR  = 0x3e;                    /* ZbgPWM[h        */
    ITU3_GRA = PWM_CYCLE;               /* ̐ݒ                   */
    ITU3_GRB = ITU3_BRB = 0;            /* [^PWMݒ            */
    ITU4_GRA = ITU4_BRA = 0;            /* E[^PWMݒ            */
    ITU4_GRB = ITU4_BRB = 0;            /* T[{PWMݒ              */
    ITU_TOER = 0x38;                    /* o͒[qI                 */

    ITU_STR = 0x09;                     /* ITŨJEgX^[g        */
}

/************************************************************************/
/* ITU0 荞ݏ                                                    */
/************************************************************************/
#pragma interrupt( interrupt_timer0 )
void interrupt_timer0( void )
{
    unsigned int    i;

    ITU0_TSR &= 0xfe;                   /* tONA                 */
    cnt1++;

    /* T[{[^ */
    servoControl();
}

/************************************************************************/
/* AiOZTTypeS̃fW^ZTlǂݍ                    */
/* @ Ȃ                                                          */
/* ߂l [AAEAE[̃fW^ZT 0: 1:              */
/************************************************************************/
unsigned char sensor_inp( void )
{
    unsigned char sensor;

    sensor  = ~P7DR >> 4 & 0x0f;        /* ʂSrbgʂɈړ     */

    return sensor;
}

/************************************************************************/
/* AiOZTTypeS̒SfW^ZTǂݍ                  */
/* @ Ȃ                                                          */
/* ߂l SfW^ZT 0: 1:                                  */
/************************************************************************/
unsigned char center_inp( void )
{
    unsigned char sensor;

    sensor  = ~P7DR & 0x08;             /* AiOZTTypeS    *//*------ ύX ------*/
    sensor  = !!sensor;                 /* SfW^ZTǂݍ   */

    return sensor;
}

/************************************************************************/
/* AiOZTTypeS̃X^[go[oZTǂݍ              */
/* @ Ȃ                                                          */
/* ߂l 0:X^[go[Ȃ 1:X^[go[                         */
/************************************************************************/
unsigned char startbar_get( void )
{
    unsigned char sensor;

    sensor  = ~PADR & 0x08;             /* AiOZTTypeS    *//*------ ύX ------*/
                                        /* X^[go[ZTǂݍ   */
    return sensor;
}

/************************************************************************/
/* fBbvXCb`lǂݍ                                           */
/* ߂l XCb`l 0`15                                              */
/************************************************************************/
unsigned char dipsw_get( void )
{
    unsigned char sw;

    sw  = ~P6DR;                        /* fBbvXCb`ǂݍ     */
    sw &= 0x0f;

    return  sw;
}

/************************************************************************/
/* vbVXCb`lǂݍ                                           */
/* ߂l XCb`l ON:1 OFF:0                                         */
/************************************************************************/
unsigned char pushsw_get( void )
{
    unsigned char sw;

    sw  = ~PBDR;                        /* XCb`̂|[gǂݍ */
    sw &= 0x01;

    return  sw;
}

/************************************************************************/
/* LED                                                              */
/* @XCb`l LED0:bit0 LED1:bit1  "0": "1":_              */
/* )0x3LED1:ON LED0:ON  0x2LED1:ON LED0:OFF                       */
/************************************************************************/
void led_out( unsigned char led )
{
    unsigned char data;

    led = ~led;
    led <<= 7;                                                            /*------ ύX ------*/
    data = PBDR & 0x7f;                                                   /*------ ύX ------*/
    PBDR = data | led;
}

/************************************************************************/
/* x                                                             */
/* @ [^:-100`100 , E[^:-100`100                       */
/*        0Œ~A100Ő]100%A-100ŋt]100%                        */
/************************************************************************/
void speed( int accele_l, int accele_r )
{
    unsigned char   sw_data;
    unsigned long   speed_max;

    sw_data  = dipsw_get() + 5;         /* fBbvXCb`ǂݍ     */
    speed_max = (unsigned long)(PWM_CYCLE-1) * sw_data / 20;

    /* [^ */
    if( accele_l >= 0 ) {
        PBDR &= 0xfb;
        ITU3_BRB = speed_max * accele_l / 100;
    } else {
        PBDR |= 0x04;
        accele_l = -accele_l;
        ITU3_BRB = speed_max * accele_l / 100;
    }

    /* E[^ */
    if( accele_r >= 0 ) {
        PBDR &= 0xf7;
        ITU4_BRA = speed_max * accele_r / 100;
    } else {
        PBDR |= 0x08;
        accele_r = -accele_r;
        ITU4_BRA = speed_max * accele_r / 100;
    }
}

/************************************************************************/
/* x2 fBbvXCb`ɂ͊֌WȂspeed֐                    */
/* @ [^:-100`100 , E[^:-100`100                       */
/*        0Œ~A100Ő]100%A-100ŋt]100%                        */
/************************************************************************/
void speed2( int accele_l, int accele_r )
{
    unsigned long   speed_max;

    speed_max = PWM_CYCLE - 1;

    /* [^ */
    if( accele_l >= 0 ) {
        PBDR &= 0xfb;
        ITU3_BRB = speed_max * accele_l / 100;
    } else {
        PBDR |= 0x04;
        accele_l = -accele_l;
        ITU3_BRB = speed_max * accele_l / 100;
    }

    /* E[^ */
    if( accele_r >= 0 ) {
        PBDR &= 0xf7;
        ITU4_BRA = speed_max * accele_r / 100;
    } else {
        PBDR |= 0x08;
        accele_r = -accele_r;
        ITU4_BRA = speed_max * accele_r / 100;
    }
}

/************************************************************************/
/* T[{nh                                                   */
/* @ T[{pxF-100`100                                     */
/************************************************************************/
void servoPwmOut( int pwm )
{
    unsigned long   pwm_max;

    pwm_max = PWM_CYCLE - 1;

    if( pwm > 0 ) {
        PBDR &= 0xbf;                                                     /*------ ύX ------*/
		ITU4_BRB = pwm_max * pwm / 100;
    } else if( pwm < 0 ) {
        PBDR |= 0x40;                                                     /*------ ύX ------*/
        pwm = -pwm;
        ITU4_BRB = pwm_max * pwm / 100;
    }
}

/*======================================================================*/
/* p֐                                                             */
/*======================================================================*/

/************************************************************************/
/* NXCo                                                 */
/* ߂l 0:NXCȂ 1:                                     */
/************************************************************************/
int check_crossline( void )
{
    unsigned char b;
    int ret = 0;

    b = sensor_inp();
    if( b==0x0f || b==0x0e || b==0x0d || b==0x0b || b==0x07 ) {
        ret = 1;
    }
    return ret;
}

/************************************************************************/
/* T[{px擾                                                       */
/* @ Ȃ                                                          */
/* ߂l S0 ŃvXAEŃ}CiX̐l                    */
/************************************************************************/
int getServoAngle( void )
{
    return( (AD_DRA>>6) - iAngle0 );                                      /*------ ύX ------*/
}

/************************************************************************/
/* AiOZTl擾                                                 */
/* @ Ȃ                                                          */
/* ߂l ZTl                                                      */
/************************************************************************/
int getAnalogSensor( void )
{
    int     ret;

    ret = (AD_DRC>>6) - (AD_DRB>>6);    /* AiOZT擾       *//*------ ύX ------*/

    if( !crank_mode ) {
        /* NN[hłȂΕ␳ */
        switch( iSensorPattern ) {
        case 0:
            if( sensor_inp() == 0x04 ) {
                ret = -650;
                break;
            }
            if( sensor_inp() == 0x02 ) {
                ret = 650;
                break;
            }
            if( sensor_inp() == 0x0c ) {
                ret = -700;
                iSensorPattern = 1;
                break;
            }
            if( sensor_inp() == 0x03 ) {
                ret = 700;
                iSensorPattern = 2;
                break;
            }
            break;

        case 1:
            /* ZTE */
            ret = -700;
            if( sensor_inp() == 0x04 ) {
                iSensorPattern = 0;
            }
            break;

        case 2:
            /* ZT */
            ret = 700;
            if( sensor_inp() == 0x02 ) {
                iSensorPattern = 0;
            }
            break;
        }
    }

    return ret;
}

/************************************************************************/
/* W[ servoControl                                            */
/* Tv     T[{[^                                        */
/*          Ȃ                                                    */
/* ߂l       O[oϐ iOutPwm ɑ                           */
/************************************************************************/
void servoControl( void )
{
    int     i, iRet, iP, iD;

    i = getAnalogSensor();              /* ZTl擾                 */

    /* T[{[^pPWMlvZ */
    iP =  5 * i;                        /*                          */
    iD = 25 * (iSensorBefore - i );     /*                          */
    iRet = iP - iD;
    iRet /= 128;

    /* PWM̏̐ݒ */
    if( iRet >  50 ) iRet =  50;        /* }CRJ[肵     */
    if( iRet < -50 ) iRet = -50;        /* 90炢ɂĂ */
    iServoPwm = iRet;

    iSensorBefore = i;                  /* ͂̒l1msO̒lƂȂ*/
}

/************************************************************************/
/* OւPWMAւPWMo@nhpx݂͌̒lgp     */
/* @ OPWM                                                       */
/* ߂l PWM                                                       */
/************************************************************************/
int diff( int pwm )
{
    int i, ret;

    i  = getServoAngle() / 5;           /* 1x̑Ŋ        */
    if( i <  0 ) i = -i;
    if( i > 45 ) i = 45;
    ret = revolution_difference[i] * pwm / 100;

    return ret;
}

/************************************************************************/
/* end of file                                                          */
/************************************************************************/
